/*
**> XOR
*/

new;
library nnet,pgraph,gWizard;

rndseed 123;

let x = { 1 1 , 1 0 , 0 1 , 0 0};
let t = {0, 1, 1, 0};

nnet_set;

_nnet_function = {1,1};
_nnet_DirectLink = 1;
_nnet_Constant = {1,1};
_nnet_SaveIters = 0;
_nnet_PrintIters = 100;
_nnet_MaxIters = 20000;
_nnet_flush = 0;
_nnet_StopRule = {1,0.999};
_nnet_opalgr = 1;

pqgwin many;

load nnet = nnet1;
{coeffs,A,Astar,B,Btilde,Bstar} = nnet_readCoeffs(nnet);
cnd_Astar = 0*Astar;
cnd_Astar[.,1] = ones(3,1);

output file = nnet2.out reset;

__title = "Neural #1";
cnd_Bstar = 0|1|0|0|0|0|0|0;
{RR,r,sv} = nnet_prune(Astar,Bstar,1-cnd_Astar,1-cnd_Bstar);
nnet_1 = nnet_fit(0,X,T,0,sv,RR,r,5);
_nnet_Jnames = 0 $+ "#" $+ ftocv(seqa(1,1,10),1,0);
{pR2_Astar,pR2_Bstar,cost_Astar,cost_Bstar,gBuffer} = nnet_analyze(nnet_1,1,0); 

graphset;
  begwind;
  window(2,2,0);

  i = 1;
  do until i > 4;

    setwind(i);
      gWizardSet(gBuffer,i);    
      str = _ptitle $+ " -- " $+ __title;
      title(str);    
      gWizardDraw(gBuffer,i);   

    i = i + 1;
  endo;
endwind;

gbuffer = nnet_plot(nnet_1,1);



__title = "Neural #2";
cnd_Bstar = 1|1|0|0|0|0|1|1;
{RR,r,sv} = nnet_prune(Astar,Bstar,1-cnd_Astar,1-cnd_Bstar);
nnet_2 = nnet_fit(0,X,T,0,sv,RR,r,5);
_nnet_Jnames = 0 $+ "#" $+ ftocv(seqa(1,1,10),1,0);
{pR2_Astar,pR2_Bstar,cost_Astar,cost_Bstar,gBuffer} = nnet_analyze(nnet_2,1,0); 

graphset;
  begwind;
  window(2,2,0);

  i = 1;
  do until i > 4;

    setwind(i);
      gWizardSet(gBuffer,i);    
      str = _ptitle $+ " -- " $+ __title;
      title(str);    
      _pframe = 0;
      gWizardDraw(gBuffer,i);   

    i = i + 1;
  endo;
endwind;

gbuffer = nnet_plot(nnet_2,1);

output off;

pred_1 = nnet_predict(nnet_1,X);
pred_2 = nnet_predict(nnet_2,X);


graphset;
  _pdate = ""; _pnum = 2; _plwidth = 10;
  title("\216Forecasting comparison");
  axmargin(1,1,1,1);
  _plctrl = 1;
  xtics(0,5,1,0);
  ytics(-0.5,1.5,0.5,0);
  _plegstr = "XOR\000nnet #1\000nnet #2";
  _plegctl = {2 6 6.5 0.6};
  xy(seqa(1,1,4),T~pred_1~pred_2);

